koa-request-validator
=============
Request validator for koa

## Classes

<dl>
<dt><a href="#Parameter">Parameter</a></dt>
<dd></dd>
<dt><a href="#RequestValidator">RequestValidator</a></dt>
<dd></dd>
</dl>

<a name="Parameter"></a>

## Parameter
**Kind**: global class  

* [Parameter](#Parameter)
    * [new Parameter(name, [location])](#new_Parameter_new)
    * _instance_
        * [.required([message])](#Parameter+required) ⇒ <code>[Parameter](#Parameter)</code>
        * [.optional()](#Parameter+optional) ⇒ <code>[Parameter](#Parameter)</code>
        * [.validate(validator, errorMessage)](#Parameter+validate) ⇒ <code>[Parameter](#Parameter)</code>
        * [.getErrorMessage(ctx)](#Parameter+getErrorMessage) ⇒ <code>Promise.&lt;(String\|undefined)&gt;</code>
    * _inner_
        * [~validatorCallback](#Parameter..validatorCallback) ⇒ <code>Boolean</code> &#124; <code>Promise.&lt;Boolean&gt;</code>

<a name="new_Parameter_new"></a>

### new Parameter(name, [location])
A parameter to validate


| Param | Type | Default | Description |
| --- | --- | --- | --- |
| name | <code>String</code> |  | Name of the parameter. Can use dotted names. |
| [location] | <code>String</code> | <code>body</code> | Location of the parameter |

<a name="Parameter+required"></a>

### parameter.required([message]) ⇒ <code>[Parameter](#Parameter)</code>
Set this parameter required

**Kind**: instance method of <code>[Parameter](#Parameter)</code>  
**Returns**: <code>[Parameter](#Parameter)</code> - - Returns the parameter object itself so that the it can be chained  

| Param | Type | Description |
| --- | --- | --- |
| [message] | <code>String</code> | Error message if this parameter is missing in the request |

<a name="Parameter+optional"></a>

### parameter.optional() ⇒ <code>[Parameter](#Parameter)</code>
Set this parameter optional

**Kind**: instance method of <code>[Parameter](#Parameter)</code>  
**Returns**: <code>[Parameter](#Parameter)</code> - - Returns the parameter object itself so that the it can be chained  
<a name="Parameter+validate"></a>

### parameter.validate(validator, errorMessage) ⇒ <code>[Parameter](#Parameter)</code>
Add a validation rule

**Kind**: instance method of <code>[Parameter](#Parameter)</code>  
**Returns**: <code>[Parameter](#Parameter)</code> - - Returns the parameter object itself so that the it can be chained  

| Param | Type | Description |
| --- | --- | --- |
| validator | <code>[validatorCallback](#Parameter..validatorCallback)</code> | A function to validate the parameter |
| errorMessage | <code>String</code> | The error message to show if invalid. |

<a name="Parameter+getErrorMessage"></a>

### parameter.getErrorMessage(ctx) ⇒ <code>Promise.&lt;(String\|undefined)&gt;</code>
Check if this parameter is valid

**Kind**: instance method of <code>[Parameter](#Parameter)</code>  
**Returns**: <code>Promise.&lt;(String\|undefined)&gt;</code> - - Returns a promise that
resolves to an error message if invalid or undefined if valid.  

| Param | Type | Description |
| --- | --- | --- |
| ctx | <code>Context</code> | The koa context object |

<a name="Parameter..validatorCallback"></a>

### Parameter~validatorCallback ⇒ <code>Boolean</code> &#124; <code>Promise.&lt;Boolean&gt;</code>
Validator Function

**Kind**: inner typedef of <code>[Parameter](#Parameter)</code>  
**Returns**: <code>Boolean</code> &#124; <code>Promise.&lt;Boolean&gt;</code> - - True for valid, false for invalid.  
**this**: <code>{Context}</code>  

| Param | Type | Description |
| --- | --- | --- |
| val | <code>\*</code> | The value to validate |

<a name="RequestValidator"></a>

## RequestValidator
**Kind**: global class  

* [RequestValidator](#RequestValidator)
    * [new RequestValidator()](#new_RequestValidator_new)
    * [.parameter(name, [location])](#RequestValidator+parameter) ⇒ <code>[Parameter](#Parameter)</code>
    * [.getError(ctx)](#RequestValidator+getError) ⇒ <code>Promise.&lt;Object&gt;</code>
    * [.middleware()](#RequestValidator+middleware) ⇒ <code>function</code>

<a name="new_RequestValidator_new"></a>

### new RequestValidator()
RequestValidator contains all the parameters to be validated

<a name="RequestValidator+parameter"></a>

### requestValidator.parameter(name, [location]) ⇒ <code>[Parameter](#Parameter)</code>
Get or create a parameter

**Kind**: instance method of <code>[RequestValidator](#RequestValidator)</code>  

| Param | Type | Default | Description |
| --- | --- | --- | --- |
| name | <code>String</code> |  | Name of the parameter |
| [location] | <code>String</code> | <code>body</code> | Location of the parameter |

<a name="RequestValidator+getError"></a>

### requestValidator.getError(ctx) ⇒ <code>Promise.&lt;Object&gt;</code>
Check if the request in the context is valid

**Kind**: instance method of <code>[RequestValidator](#RequestValidator)</code>  
**Returns**: <code>Promise.&lt;Object&gt;</code> - - The error object  

| Param | Type | Description |
| --- | --- | --- |
| ctx | <code>Context</code> | The koa context object |

<a name="RequestValidator+middleware"></a>

### requestValidator.middleware() ⇒ <code>function</code>
Get the koa middleware

**Kind**: instance method of <code>[RequestValidator](#RequestValidator)</code>  
